



from PyQt4.QtCore import *
from PyQt4.QtGui import *

import os, sys

app = QApplication(sys.argv)

if(os.path.exists("/home/user/MyDocs")): DeviceIsN900=True    #runs on real N900 hardware
else: DeviceIsN900=False    #runs on other hardware/OS, deactivate features, simulate some functions

print "DeviceIsN900:",  DeviceIsN900

if(DeviceIsN900==True): 
    import location
else:
    location=None
    
    
import gobject

import math


loop = gobject.MainLoop()




#GUI files, generated with QT designer
from Ui_StartWindow import *
from Ui_EditWindow import *


DB_ENTRIES = 10
COLUMNS=8


#Container for coordinates 
class coordinate():
    location=""
    used=False
    enabled=False
    lat=0
    lon=0
    eph=0
    radius=100
    distance=0
    status=0
    Alert_triggered=False
    PreAlert_triggered=False





here=coordinate()
POI = []

selected_entry=-1



for i in range(0,  DB_ENTRIES):
    POI.append(coordinate())

















    
def main():
    global StartWindow,  EditWindow
    


    
    #Create main window
    StartWindow = frmStartWindow()
    StartWindow.show()
    EditWindow = frmEditWindow()
    EditWindow.hide()
 
    app.processEvents() #force ui update
 
    print "init location service..."
 

    print "DeviceIsN900:",  DeviceIsN900

    if(DeviceIsN900==True): 
        control = location.GPSDControl.get_default()
        device = location.GPSDevice()
        control.set_properties(preferred_method=location.METHOD_USER_SELECTED, preferred_interval=location.INTERVAL_DEFAULT)

        control.connect("error-verbose", on_error, loop)
        device.connect("changed", on_changed, control)
        control.connect("gpsd-stopped", on_stop, loop)

        gobject.idle_add(start_location, control)






    POI[5].location ="Home"
    POI[5].used=True
    POI[5].enabled=True
    POI[5].lat = 47.4105333333
    POI[5].lon = 8.72685
    POI[5].radius=10
    
    POI[3].location ="Post"
    POI[3].used=True
    POI[3].enabled=True
    POI[3].lat = 47.4078
    POI[3].lon = 8.7238
    POI[3].radius=200
    
    POI[2].location ="Bahnhof Uster"
    POI[2].used=True
    POI[2].enabled=True
    POI[2].lat = 47.35105
    POI[2].lon = 8.7174666667
    POI[2].radius=80





    print "Stored POIs:"
    for i in range(0,  DB_ENTRIES):
        print i, ":",  POI[i].location, POI[i].radius, POI[i].lat,  POI[i].lon,   POI[i].eph
     
    print "==== INIT DONE ============================================"
     
     
    
     
    StartWindow.UpdateScreen()
     
    loop.run() 
    
    
    








def Process_Data():
    here.distance=0 #get closest active location
    
    for i in range(0,  DB_ENTRIES):
        if(POI[i].distance<POI[i].radius):
            if(POI[i].Alert_triggered==False):
                POI[i].Alert_triggered=True
                POI[i].status=2 #Here
        elif(POI[i].distance<POI[i].radius*5):
            if(POI[i].PreAlert_triggered==False):
                POI[i].PreAlert_triggered=True
                POI[i].status=1 #Near
        else:
            POI[i].status=0 #Far
            
            
        
        if(POI[i].used==True):
            if(POI[i].distance<here.distance or here.distance==0): here.distance=POI[i].distance











def distance_on_unit_sphere(lat1, lon1, lat2, lon2):
    
#    print "distance_on_unit_sphere( lat1:",  lat1, "lon:",  lon1, "lat2:",  lat2, "lon2:",  lon2,  ")"

    # Convert latitude and longitude to 
    # spherical coordinates in radians.
    degrees_to_radians = math.pi/180.0
        
    # phi = 90 - latitude
    phi1 = (90.0 - lat1)*degrees_to_radians
    phi2 = (90.0 - lat2)*degrees_to_radians
        
    # theta = longitude
    theta1 = lon1*degrees_to_radians
    theta2 = lon2*degrees_to_radians
        
    # Compute spherical distance from spherical coordinates.
        
    # For two locations in spherical coordinates 
    # (1, theta, phi) and (1, theta, phi)
    # cosine( arc length ) = 
    #    sin phi sin phi' cos(theta-theta') + cos phi cos phi'
    # distance = rho * arc length
    
    cos = (math.sin(phi1)*math.sin(phi2)*math.cos(theta1 - theta2) + 
           math.cos(phi1)*math.cos(phi2))
    arc = math.acos( cos )

    # Remember to multiply arc by the radius of the earth 
    # in your favorite set of units to get length.
    return arc * 6373 * 1000 #in meter
    













def on_error(control, error, data):
    print "location error: %d... quitting" % error
    data.quit()
 
 
 
 
 
def on_changed(device, data):
    if not device:
        return
    if device.fix:
#        Format of device.fix:
#       0 mode: The mode of the fix
#       1 fields: A bitfield representing which items of this tuple contain valid data
#       2 time: The timestamp of the update (location.GPS_DEVICE_TIME_SET)
#       3 ept: Time accuracy
#       4 latitude: Fix latitude (location.GPS_DEVICE_LATLONG_SET)
#       5 longitude: Fix longitude (location.GPS_DEVICE_LATLONG_SET)
#       6 eph: Horizontal position accuracy
#       7 altitude: Fix altitude in meters (location.GPS_DEVICE_ALTITUDE_SET)
#       8 double epv: Vertical position accuracy
#       9 track: Direction of motion in degrees (location.GPS_DEVICE_TRACK_SET)
#     10 epd: Track accuracy
#     11 speed: Current speed in km/h (location.GPS_DEVICE_SPEED_SET)
#     12 eps: Speed accuracy
#     13 climb: Current rate of climb in m/s (location.GPS_DEVICE_CLIMB_SET)
#     14 epc: Climb accuracy 
        
        
        if device.fix[1] & location.GPS_DEVICE_LATLONG_SET:
 
            #Store current position
            here.lat=device.fix[4]
            here.lon=device.fix[5]
            here.eph=device.fix[6]/100 #in meters
            
            print "\n\n"
            print "Current position:",  "lat:",  round(here.lat,  3), ",  lon:",  round(here.lon,  3),  ", eph:",  int(here.eph)
 
            print "Distances to POIs:"
            for i in range(0,  DB_ENTRIES):
                if(POI[i].location != ""):
                    POI[i].distance=distance_on_unit_sphere(here.lat, here.lon, POI[i].lat,  POI[i].lon) 
                    print i, ":",  POI[i].location, int(POI[i].distance),  "m"
                    
                    
                    
            Process_Data()
            StartWindow.UpdateScreen()
 
 
 
 
 
def on_stop(control, data):
    print "quitting"
    data.quit()
 
 
 
 
def start_location(data):
    data.start()
    return False
 























    
    
    
    
    
    
    
class frmStartWindow(QMainWindow):
    def __init__(self):
        QMainWindow.__init__(self)
        try:
            self.setAttribute(Qt.WA_Maemo5StackedWindow) # This attribute makes the whole Stacked Window thing work
        except:
            pass
        self.ui = Ui_StartWindow()
        self.ui.setupUi(self)
        
        self.ui.tableWidget.setRowCount(DB_ENTRIES)
        
        
        for j in range(0,  COLUMNS):
            for i in range(0,  DB_ENTRIES):
                self.ui.tableWidget.setItem(i,  j, QtGui.QTableWidgetItem())
                            
#        self.ui.tableWidget.setCurrentCell(0, 0) #select first row

                
##            newitem = QtGui.QCheckBox()
#            newitem = QtGui.QComboBox()
#            newitem.insertItems(0,"aa")
#            newitem.insertItems(0,"aa")
#            self.connect(newitem, QtCore.SIGNAL("currentIndexChanged(int)"), self.signalMapper, QtCore.SLOT("map()"))
#            self.signalMapper.setMapping(newitem,item)
#            self.ui.tableWidget.setCellWidget(0,  3,newitem)
        
        
        
        
        
        
        QtCore.QObject.connect(self.ui.tableWidget, QtCore.SIGNAL("itemSelectionChanged()"), self.TableSelectionChanged)
        
        
        QtCore.QObject.connect(self.ui.bEnable, QtCore.SIGNAL("clicked()"), self.Enable)
        QtCore.QObject.connect(self.ui.bEdit, QtCore.SIGNAL("clicked()"), self.Edit)
        QtCore.QObject.connect(self.ui.bAdd, QtCore.SIGNAL("clicked()"), self.Add)
        QtCore.QObject.connect(self.ui.bRemove, QtCore.SIGNAL("clicked()"), self.Remove)
        
        
        
        
        
        
        
        
        
    def TableSelectionChanged(self):
        global selected_entry
        
        row=self.ui.tableWidget.selectedIndexes()[0].row()
        selected_entry=int(self.ui.tableWidget.item(row, 7).text())
        
        print "current selected entry:",  selected_entry
        
        self.ui.bEnable.setEnabled(True)
        self.ui.bEdit.setEnabled(True)
        self.ui.bRemove.setEnabled(True)
        
        
        
    def Enable(self):
        pass
        
        
        
        
    def Edit(self):
        EditWindow.UpdateScreen()
        EditWindow.show()
        
        
        
        
    def Add(self):
        pass
        
        
        
        
    def Remove(self):
        pass
        
        
        
        
        
        
        
    
    def UpdateScreen(self):        
        txt="Now: Lat="+str(round(here.lat, 3))+", Lon="+str(round(here.lat, 3))+" +/- "+str(int(here.eph))+ "m"
        if(here.distance >0): txt=txt+ ", Closest active distance="+str(int(here.distance))+"m"
        self.ui.lStatus.setText(QtGui.QApplication.translate("StartWindow", txt, None, QtGui.QApplication.UnicodeUTF8))
        
#        closest_row=0
        row=0
        for i in range(0,  DB_ENTRIES):
            if(POI[i].used==True):
#                print "add location",  i,  "to table"
                self.ui.tableWidget.item(row, 0).setText(QtGui.QApplication.translate("StartWindow", str(POI[i].location), None, QtGui.QApplication.UnicodeUTF8))
                if(POI[i].enabled==True):
                    self.ui.tableWidget.item(row, 1).setText(QtGui.QApplication.translate("StartWindow", "Yes", None, QtGui.QApplication.UnicodeUTF8))
                else:
                    self.ui.tableWidget.item(row, 1).setText(QtGui.QApplication.translate("StartWindow", "No", None, QtGui.QApplication.UnicodeUTF8))
                self.ui.tableWidget.item(row, 2).setText(QtGui.QApplication.translate("StartWindow", str(int(POI[i].radius))+"m", None, QtGui.QApplication.UnicodeUTF8))
                self.ui.tableWidget.item(row, 3).setText(QtGui.QApplication.translate("StartWindow", str(int(POI[i].distance))+"m", None, QtGui.QApplication.UnicodeUTF8))
                self.ui.tableWidget.item(row, 4).setText(QtGui.QApplication.translate("StartWindow", str(round(POI[i].lat, 3))+"", None, QtGui.QApplication.UnicodeUTF8))
                self.ui.tableWidget.item(row, 5).setText(QtGui.QApplication.translate("StartWindow", str(round(POI[i].lon, 3))+"", None, QtGui.QApplication.UnicodeUTF8))
                if(POI[i].status==0):
                    self.ui.tableWidget.item(row, 6).setText(QtGui.QApplication.translate("StartWindow", "Far", None, QtGui.QApplication.UnicodeUTF8))
                elif(POI[i].status==1):
                    self.ui.tableWidget.item(row, 6).setText(QtGui.QApplication.translate("StartWindow", "Near", None, QtGui.QApplication.UnicodeUTF8))
                elif(POI[i].status==2):
                    self.ui.tableWidget.item(row, 6).setText(QtGui.QApplication.translate("StartWindow", "Here", None, QtGui.QApplication.UnicodeUTF8))
                    
                self.ui.tableWidget.item(row, 7).setText(QtGui.QApplication.translate("StartWindow", str(i), None, QtGui.QApplication.UnicodeUTF8)) #store index of array entry
                    
#                if(POI[i].distance)<closest_row or closest_row==0): closest_row=POI[i].distance)
                row=row+1
            
        self.ui.tableWidget.setRowCount(row) #hide unused rows
    
#        self.ui.tableWidget.sortItems(3) #sort for distance
                
        if(row==0 or selected_entry == -1): #no row shown, disable some buttons
            self.ui.bEnable.setEnabled(False)
            self.ui.bEdit.setEnabled(False)
            self.ui.bRemove.setEnabled(False)
        else: #enable all buttons
            self.ui.bEnable.setEnabled(True)
            self.ui.bEdit.setEnabled(True)
            self.ui.bRemove.setEnabled(True)
    
        
        
        
        
        
    
    
    def closeEvent(self, event): ##(Class StartWindow)
        print "Close application"
        loop.quit()

    
    
    
    
    
    
    
    
    
    

    
class frmEditWindow(QDialog):
    def __init__(self, parent=None):
        QMainWindow.__init__(self, parent) # Notice that you must give a parent window as parameter to the constuctor
        try:
            if(data.DeviceIsN900==True): self.setAttribute(Qt.WA_Maemo5StackedWindow) # This attribute makes the whole Stacked Window thing work
        except:
            pass
        self.ui = Ui_EditWindow()
        self.ui.setupUi(self)
    
    
    
    def UpdateScreen(self):
        global selected_entry
        print "selected entry:",  selected_entry
        self.ui.tLocation.setText(POI[int(selected_entry)].location)
        
        latitude=POI[selected_entry].lat
        degrees=int(latitude)
        minutes=(latitude-degrees) * 60
        
        self.ui.sLatDegrees.setValue(degrees)
        self.ui.sLatMinutes.setValue(minutes)
        
        longitude=POI[int(selected_entry)].lon
        degrees=int(longitude)
        minutes=(longitude-degrees) * 60
        
        self.ui.sLonDegrees.setValue(degrees)
        self.ui.sLonMinutes.setValue(minutes)
        
        
        self.ui.sRadius.setValue(POI[int(selected_entry)].radius)
        
        
        
        
        
    
    
    
main()
